﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.DocIO.DLS;
using Syncfusion.DocIO;

namespace GenerateWord_2010
{
    public partial class GenerateWord : System.Web.UI.Page
    {
        private string _findAllText;
        protected void Page_Load(object sender, EventArgs e)
        {

        }
        /// <summary>
        /// Creates a Word document
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Button1_Click(object sender, EventArgs e)
        {
            //Get the template document file path
            string inputFile = this.Server.MapPath("Data") + @"\Adventure.docx";
            // Creating a new document.
            WordDocument document = new WordDocument();
            //Open the template document
            document.Open(inputFile);
            //Find all the matching text in document            
            TextSelection[] textSelections = document.FindAll(_findAllText, false, true);
            if (rdButtonRemoveOwnerPara.Checked)
            {
                if (textSelections != null)
                {
                    //Remove the paragraph from the owner text body.
                    foreach (TextSelection selection in textSelections)
                    {
                        WTextRange textRange = selection.GetAsOneRange();
                        //Get the owner textbody of the paragraph and remove the paragraph from it 
                        WTextBody ownerTextBody = textRange.OwnerParagraph.OwnerTextBody;
                        if (ownerTextBody != null)
                            ownerTextBody.ChildEntities.Remove(textRange.OwnerParagraph);
                    }
                }
                //Save as .docx format
                document.Save("Sample.docx", FormatType.Docx, Response, HttpContentDisposition.Attachment);
                document.Close();
            }
            else if (rdButtonRemovePrevAndNextPara.Checked)
            {
                if (textSelections != null)
                {
                    //Remove the previous and next empty paragraph of the specified text paragraph from the owner text body.
                    foreach (TextSelection selection in textSelections)
                    {
                        WTextRange textRange = selection.GetAsOneRange();
                        WTextBody ownerTextBody = textRange.OwnerParagraph.OwnerTextBody;
                        //Get the index of the paragraph with specified text
                        int ownerParaIndex = ownerTextBody.ChildEntities.IndexOf(textRange.OwnerParagraph);
                        //Check whether the previous and next paragraphs are empty and remove them
                        if (ownerParaIndex > 0 && ownerTextBody.ChildEntities[ownerParaIndex - 1] is WParagraph &&
                            (ownerTextBody.ChildEntities[ownerParaIndex - 1] as WParagraph).Items.Count == 0)
                        {
                            ownerTextBody.ChildEntities.RemoveAt(ownerParaIndex - 1);
                        }
                        if (ownerParaIndex + 1 < ownerTextBody.ChildEntities.Count &&
                            ownerTextBody.ChildEntities[ownerParaIndex + 1] is WParagraph &&
                            (ownerTextBody.ChildEntities[ownerParaIndex + 1] as WParagraph).Items.Count == 0)
                        {
                            ownerTextBody.ChildEntities.RemoveAt(ownerParaIndex + 1);
                        }
                    }
                }
                //Save as .docx format
                document.Save("Sample.docx", FormatType.Docx, Response, HttpContentDisposition.Attachment);
                document.Close();
            }
        }
        protected void TextBox1_TextChanged(object sender, EventArgs e)
        {            
            _findAllText = TextBox1.Text;
        }

        protected void rdButtonRemovePrevAndNextPara_CheckedChanged(object sender, EventArgs e)
        {

        }

        protected void rdButtonOwnerPara_CheckedChanged(object sender, EventArgs e)
        {

        }
    }
}